/*
 The software in this package is distributed under the GNU General
 Public License version 2 (with a special exception described below).

 A copy of GNU General Public License (GPL) is included in this distribution,
 in the file COPYING.GPL.

 As a special exception, if other files instantiate templates or use macros
 or inline functions from this file, or you compile this file and link it
 with other works to produce a work based on this file, this file
 does not by itself cause the resulting work to be covered
 by the GNU General Public License.

 However the source code for this file must still be made available
 in accordance with section (3) of the GNU General Public License.

 This exception does not invalidate any other reasons why a work based
 on this file might be covered by the GNU General Public License.

 Christian Herdtweck, Intra2net AG 2015
 */

#ifndef IP_PSEUDO_RESOLVER_H
#define IP_PSEUDO_RESOLVER_H

#include "dns_neww/resolverbase.h"
#include "dns_neww/dnsmaster.h"

/** @brief Degenerate case of a resolver: hostname is already an IP
 * 
 * created by DnsMaster if given an IP address as hostname
 *
 * Will do nothing, just remember that IP and return it for every call to
 * get_next_ip
 *
 * Since this is so boring, I did not create an own .cpp for it
 */
class IpPseudoResolver : public ResolverBase
{
// constructor accessible from friend DnsMaster
public:
    friend DnsMaster::create_resolver_for(const std::string &hostname);
private:
    IpPseudoResolver(const std::string ip) : IP(ip)  {}

private:
    const std::string IP;

// only function, inherited from ResolverBase
public:
    std::string get_next_ip()  { return IP;  }
};
#endif

// (created using vim -- the world's best text editor)

